# get links from url
function geturl() {
	url="$1"
	cmd=''
	if [[ "$url" =~ ^ftp ]]; then
		lynx -connect_timeout=5 -read_timeout=5 -passive-ftp -listonly -dump $url
	else
		curl -m 10 -sLk $url | lynx -stdin -listonly -dump
	fi | grep -E '^ *[0-9]+\. +' | sed -r 's/^ *[0-9]+\. *(.*)$/\1/'
}

# get files from url
function urllist() {
	geturl "$@" | sed -r 's/^.*\/([^\/]+)\/?$/\1/'
}

# list sourceforge project files
function sflist() {
	project="$1"
	path="$2"
	geturl "http://sourceforge.net/projects/$project/files/$path" | grep -E "$project/files/$path(/[^/])?" | while read n; do
		if [[ "$n" =~ /$ ]]; then
			echo $n | sed -r 's/^.*\/([^\/]+)\/$/\1/'
		elif [[ "$n" =~ /download$ ]]; then
			echo "$n" | sed -r 's/^.*\/([^\/]+)\/download$/\1/'
		fi
	done
}

# script for gnome projects
function u2dgnome {
	project="$1"
	ver="$(urllist "ftp://ftp.gnome.org/pub/gnome/sources/$project/" | grep -E '^[0-9]+\.[0-9]*[02468](\.[0-9.])?$' | sort -V | tail -n 1)"
	urllist "ftp://ftp.gnome.org/pub/gnome/sources/$project/$ver" | grep LATEST-IS | sed -r 's/LATEST-IS-//'
}

# automatically parse version number from file
function parsever() {
	grep -E '.*-([0-9.-]+)\.((tar\.)|(t))?(gz|bz2|xz)$' | sed -r 's/.*-([0-9.-]+)\.((tar\.)|(t))?(gz|bz2|xz)/\1/'
}

# split version number from file
function splitver() {
	num=1
	if [ "$#" -eq 2 ]; then
		num="$2"
	fi
	if [ "$#" -eq 0 ]; then
		pattern='.*-([0-9.]+)\.((tar\.)|(t))?(gz|bz2|xz)$'
	else 
		pattern="$1"
	fi
	
	grep -E "$pattern" | sed -r 's/'$pattern'/\'$num'/'
}

function u2dcpan() {
	ver="$(curl -m 10 -s http://cpanmetadb.plackperl.org/v1.0/package/$1 | grep version)"
	echo "${ver##*: }"
}
